/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow;

import java.util.ArrayList;

/**
 *
 * @author madda
 */
public class DataBus {

    ArrayList<DataChannel> channels;

    public DataBus() {
        this.channels = new ArrayList<DataChannel>();
    }

    public void addChannel(int index, DataChannel d) {
        if (index > this.channels.size()) {
            int i = 0;
            while (i < index) {
                this.channels.add(null);
                i++;
            }
        }
        this.channels.add(index, d);
    }

    public String readSpecific(int id) {
        Packet ret = channels.get(id).read();
        return ret.getTextContent();
    }

    public void writeSpecific(int id, String s) {
        Packet temp = new Packet(s);
        channels.get(id).write(temp);
    }

    public void writeToAll(String s) {
        Packet temp = new Packet(s);
        for (int i = 0; i < channels.size(); i++) {
            channels.get(i).write(temp);
        }
    }

    public boolean hasInputs() {
        for (int i = 0; i < channels.size(); i++) {
            if (channels.get(i).isEmpty()) {
                return false;
            }
        }
        return true;
    }


    public int size() {
        return channels.size();
    }

    public void commit() {
        for (int i = 0; i < channels.size(); i++) {
            channels.get(i).commit();
        }
        System.out.println("Commitujem vysledky");
    }

    public void returnToSpecific(int id,String s){
        Packet temp = new Packet(s);
        channels.get(id).placeAtBegining(temp);
    }
}
