/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.main;

import baka.dataflow.Conversion;
import baka.gui.GraphicCanvas;
import java.io.File;

/**
 *
 * @author madda
 */
public class VFLinterpreter {

    public static void main(String[] args) {
        String ConversionFile = "";
        if (args.length == 0) {
            System.out.println("WRONG USAGE of VFLinterpreter. No arguments provided.");
        }
        ConversionFile = args[0];
        if (args.length == 1) {
            File f = new File(ConversionFile);
            Conversion c = new Conversion(f, new GraphicCanvas(null));
            System.out.println("Conversion has " + c.getInterpreterInformations());
        } else {
            File f = new File(ConversionFile);
            Conversion c = new Conversion(f, new GraphicCanvas(null));
            String type = args[1];
            if (type.equals("-s")) {
                c.conversionType = 0;
            } else if (type.equals("-a")) {
                c.conversionType = 1;
            }
            for (int i = 2; i < args.length; i += 2) {
                String id = args[i].substring(1);
                System.out.println("ID:" + id);
                String path = args[i + 1];
                System.out.println("PATH:" + path);
                c.setFileLocation(Integer.parseInt(id), path);
            }
            try {
                c.executeConversion();
                System.out.println("Conversion successfully executed.");
            }catch(Exception e){
                System.out.println("Error during execution of conversion.");
                System.out.println(e.getMessage());
            }
        }
    }
}
